<script context="module" lang="ts">
    import type { LoadInput, LoadOutput } from '@sveltejs/kit/types/page'

    export function load({ page }: LoadInput): LoadOutput {
        return {
            props: {
                id: page.params.id
            }
        }
    }
</script>

<script lang="ts">
    import type { Writable } from 'svelte/store'
    import DistrictPanel from '$components/District/DistrictPanel.svelte'
    import FieldPanel from '$components/District/FieldPanel.svelte'
    import ResourcesPanel from '$components/District/ResourcesPanel.svelte'
    import { default as MapComponent } from '$components/District/Map.svelte'
    import InGame from '$components/Layouts/InGame.svelte'
    import type { Resources } from '$lib/resource'
    import { districts } from '$lib/districts'
    import type Tile from '$lib/map/Tile'
    import Map from '$lib/map/Map'
    import type District from '$models/District'
    import fieldContentFactory from '$utils/fieldContentFactory'

    export let id: number

    let district: District
    let map: Map
    let loaded = false
    let resources: Writable<Resources> = null
    $: {
        if ($districts.length) {
            district = $districts[id]
            map = new Map(district)
            district.setResourcesStore().then(() => {
                loaded = true
                resources = district.getResources().store
            })
        }
    }

    let unique = {}
    let tile: Tile

    const selectField = (selected: Tile) => {
        clearZeroBuilding()
        tile = selected
        unique = {} // {} === {} is false
    }

    const handleNewBuilding = (event: CustomEvent) => {
        tile.districtField = fieldContentFactory(
            {
                x: tile.q + tile.offset,
                y: tile.r,
                value: event.detail,
                level: 0
            },
            district
        )
        unique = {}
    }

    // Empty the field
    const handleCancel = () => {
        clearZeroBuilding()
        tile = undefined
        map.blur()
    }

    // Clear the content of a field if it was occupied by a level 0 building
    const clearZeroBuilding = () => {
        if (
            tile?.districtField &&
            tile.districtField.isBuilding() &&
            tile.districtField.level === 0
        ) {
            tile.districtField = null
        }
    }
</script>

<svelte:head>
    <title>{`#${id} ${district?.name ?? ''}`}</title>
</svelte:head>

<InGame {loaded}>
    <svelte:fragment slot="header-left">
        <ResourcesPanel {resources} />
    </svelte:fragment>

    <article>
        <aside>
            {#if tile}
                {#key unique}
                    <FieldPanel
                        {district}
                        bind:tile
                        on:cancel={handleCancel}
                        on:newBuilding={handleNewBuilding}
                    />
                {/key}
            {:else}
                <DistrictPanel {district} />
            {/if}
        </aside>
        <main>
            {#if map}
                <MapComponent on:selectField={event => selectField(event.detail)} {map} />
            {/if}
        </main>
    </article>
</InGame>

<style lang="postcss">
    article {
        @apply relative h-screen flex-1 flex pt-[4.5rem];

        aside {
            @apply relative h-full w-[calc(2/7*100%)] overflow-y-hidden;
            clip-path: polygon(calc(100% - 2rem) 0.75rem, 100% 100%, 0 100%, 0 0);

            &::before {
                content: '';
                @apply absolute inset-0 z-[-1] bg-trueGray-100 dark:bg-trueGray-900;
            }
        }

        main {
            @apply flex-1 flex pl-4 pr-8 py-4;
        }
    }
</style>
